import { Percentage } from "@orca-so/common-sdk";
import { Address } from "@project-serum/anchor";
import { u64 } from "@solana/spl-token";
import { AccountFetcher } from "../../network/public";
import { WhirlpoolDiscountInfoData } from "../../types/public";
import { Whirlpool } from "../../whirlpool-client";
import { NormalSwapQuote, SwapQuoteParam } from "./swap-quote";
import { PublicKey } from "@solana/web3.js";
export declare type FeeDiscountSwapQuote = NormalSwapQuote & {
    estimatedDiscountAmount: u64;
    estimatedBurnAmount: u64;
};
/**
 * @category Quotes
 * @TODO additional function
 * @param whirlpool
 * @param inputTokenMint
 * @param tokenAmount
 * @param slippageTolerance
 * @param programId
 * @param fetcher
 * @param refresh
 * @returns
 */
export declare function swapWithFeeDiscountQuoteByInputToken(whirlpool: Whirlpool, discountToken: PublicKey, inputTokenMint: Address, tokenAmount: u64, slippageTolerance: Percentage, programId: Address, fetcher: AccountFetcher, refresh: boolean): Promise<FeeDiscountSwapQuote>;
export declare function swapWithFeeDiscountQuoteByOutputToken(whirlpool: Whirlpool, whirlpoolDiscountInfoData: WhirlpoolDiscountInfoData, outputTokenMint: Address, tokenAmount: u64, slippageTolerance: Percentage, programId: Address, fetcher: AccountFetcher, refresh: boolean): Promise<FeeDiscountSwapQuote>;
/**
 * Get the token type of the input token for this swap quote.
 *
 * @category Quotes
 * @param quote - SwapQuote object
 * @returns the TokenType of the input token
 */
export declare function swapWithFeeDiscountQuoteWithParams(params: SwapQuoteParam, whirlpoolDiscountInfoData: WhirlpoolDiscountInfoData, slippageTolerance: Percentage): FeeDiscountSwapQuote;
